> For the complete documentation index, see [llms.txt](https://docs.ipwo.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ipwo.net/kai-fa-zhe-wen-dang/dai-ma-shi-li/c.md).

# C\#

使用 C# 可以通过 [IPWO 代理](https://www.ipwo.net/)发起 HTTP 请求，适用于 API 服务、数据采集与自动化开发场景。

***

### 一、HTTP 代理示例

```csharp
using System.Net;

var handler = new HttpClientHandler
{
    UseProxy = true
};

var proxy = new WebProxy(
    "http://us.ipwo.net:7878"
);

var proxyUsername =
    "username_custom_zone_us";

var proxyPass = "password";

proxy.Credentials =
    new NetworkCredential(
        proxyUsername,
        proxyPass
    );

handler.Proxy = proxy;

var httpClient =
    new HttpClient(handler);

httpClient.Timeout =
    TimeSpan.FromSeconds(15);

var task = httpClient.GetStringAsync(
    "http://ipinfo.io/json"
);

task.Wait();

Console.WriteLine(task.Result);
```

***

### 二、正常返回示例

```json
{
  "ip": "203.0.113.10",
  "country": "US"
}
```

如果返回的 IP：

* 不是本机公网 IP
* 国家地区正确

说明代理已经生效。

***

### 三、增加 Timeout（推荐）

建议：

```csharp
httpClient.Timeout =
    TimeSpan.FromSeconds(30);
```

避免请求长时间卡住。

***

### 四、常见问题

#### [407 Proxy Authentication Required](/kai-fa-zhe-wen-dang/chang-jian-cuo-wu/407-proxy-authentication-required.md)

通常是：

* 用户名错误
* 密码错误
* zone 参数错误

***

#### [Timeout 超时](/kai-fa-zhe-wen-dang/chang-jian-cuo-wu/chao-shi-timeout.md)

通常是：

* 网络环境异常
* DNS 问题
* 请求超时时间过短

***

#### IP 未变化

请检查：

* 是否正确设置 Proxy
* 请求是否真正走代理

***

### 五、推荐开发建议

推荐：

* 使用海外 VPS
* 增加 timeout
* 增加 Retry 重试机制
* 使用粘性 Session

适用于：

* API 服务
* 自动化程序
* 数据采集
* 企业应用

***

### 六、相关文章

* [Go](/kai-fa-zhe-wen-dang/dai-ma-shi-li/go.md)
* [Java](/kai-fa-zhe-wen-dang/dai-ma-shi-li/java.md)
* [PHP](/kai-fa-zhe-wen-dang/dai-ma-shi-li/java.md)&#x20;
* [Python Requests](/kai-fa-zhe-wen-dang/dai-ma-shi-li/python/requests.md)
* [API 调用与批量采集](/dai-li-ji-chu-zhi-shi/api-diao-yong-yu-pi-liang-cai-ji.md)
* [超时 Timeout](/kai-fa-zhe-wen-dang/chang-jian-cuo-wu/chao-shi-timeout.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ipwo.net/kai-fa-zhe-wen-dang/dai-ma-shi-li/c.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
